diff --git a/src/ck-session.c b/src/ck-session.c
index d8db9dd..0354dd5 100644
--- a/src/ck-session.c
+++ b/src/ck-session.c
@@ -1301,6 +1845,10 @@ ck_session_dump (CkSession *session,
         char *s;
         char *group_name;
 
+        if (!session->priv->is_open) {
+                return;
+        }
+
         group_name = g_strdup_printf ("Session %s", session->priv->id);
         g_key_file_set_integer (key_file, group_name, "uid", session->priv->uid);
         g_key_file_set_string (key_file,
@@ -1313,6 +1861,12 @@ ck_session_dump (CkSession *session,
                                        "type",
                                        NONULL_STRING (session->priv->session_type));
         }
+        if (session->priv->display_type != NULL) {
+                g_key_file_set_string (key_file,
+                                       group_name,
+                                       "display_type",
+                                       NONULL_STRING (session->priv->display_type));
+        }
         if (session->priv->login_session_id != NULL && strlen (session->priv->login_session_id) > 0) {
                 g_key_file_set_string (key_file,
                                        group_name,
diff --git a/src/ck-session.h b/src/ck-session.h
index b6b565b..a24d0a8 100644
--- a/src/ck-session.h
+++ b/src/ck-session.h
@@ -25,6 +25,8 @@
 #include <glib-object.h>
 #include <dbus/dbus-glib.h>
 
+#include "ck-display-template.h"
+
 G_BEGIN_DECLS
 
 #define CK_TYPE_SESSION         (ck_session_get_type ())
@@ -68,10 +70,15 @@ typedef enum
 
 GQuark              ck_session_error_quark            (void);
 GType               ck_session_get_type               (void);
+CkSession         * ck_session_new_from_file          (const char            *ssid,
+                                                       const char            *path);
 CkSession         * ck_session_new                    (const char            *ssid,
-                                                       const char            *cookie);
+                                                       const char            *type,
+                                                       const char            *display_type_string,
+                                                       GHashTable            *display_variables);
 CkSession         * ck_session_new_with_parameters    (const char            *ssid,
-                                                       const char            *cookie,
+                                                       const GPtrArray       *parameters);
+void                ck_session_set_parameters         (CkSession             *session,
                                                        const GPtrArray       *parameters);
 
 void                ck_session_dump                   (CkSession             *session,
@@ -86,6 +93,15 @@ gboolean            ck_session_set_active             (CkSession             *se
 gboolean            ck_session_set_is_local           (CkSession             *session,
                                                        gboolean               is_local,
                                                        GError               **error);
+gboolean            ck_session_set_is_open            (CkSession             *session,
+                                                       gboolean               is_open,
+                                                       GError               **error);
+gboolean            ck_session_set_ever_open          (CkSession             *session,
+                                                       gboolean               ever_open,
+                                                       GError               **error);
+gboolean            ck_session_set_under_request      (CkSession             *session,
+                                                       gboolean               under_request,
+                                                       GError               **error);
 gboolean            ck_session_set_id                 (CkSession             *session,
                                                        const char            *ssid,
                                                        GError               **error);
@@ -116,6 +132,11 @@ gboolean            ck_session_set_remote_host_name   (CkSession             *se
 gboolean            ck_session_set_session_type       (CkSession             *session,
                                                        const char            *type,
                                                        GError               **error);
+gboolean            ck_session_set_display_type       (CkSession             *session,
+                                                       const char            *type,
+                                                       GError               **error);
+GHashTable         *ck_session_get_display_variables  (CkSession             *session);
+CkDisplayTemplate  *ck_session_get_display_template   (CkSession             *session);
 
 /* Exported methods */
 
@@ -132,6 +153,15 @@ gboolean            ck_session_is_active              (CkSession             *se
 gboolean            ck_session_is_local               (CkSession             *session,
                                                        gboolean              *local,
                                                        GError               **error);
+gboolean            ck_session_is_open                (CkSession             *session,
+                                                       gboolean              *open,
+                                                       GError               **error);
+gboolean            ck_session_get_ever_open          (CkSession             *session,
+                                                       gboolean              *open,
+                                                       GError               **error);
+gboolean            ck_session_get_under_request      (CkSession             *session,
+                                                       gboolean              *under_request,
+                                                       GError               **error);
 gboolean            ck_session_get_unix_user          (CkSession             *session,
                                                        guint                 *uid,
                                                        GError               **error);
@@ -150,12 +180,18 @@ gboolean            ck_session_get_login_session_id   (CkSession             *se
 gboolean            ck_session_get_session_type       (CkSession             *session,
                                                        char                 **type,
                                                        GError               **error);
+gboolean            ck_session_get_display_type       (CkSession             *session,
+                                                       char                 **type,
+                                                       GError               **error);
 gboolean            ck_session_get_remote_host_name   (CkSession             *session,
                                                        char                 **host_name,
                                                        GError               **error);
 gboolean            ck_session_get_creation_time      (CkSession             *session,
                                                        char                 **iso8601_datetime,
                                                        GError               **error);
+gboolean            ck_session_get_remove_on_close    (CkSession             *session,
+                                                       gboolean              *remove_on_close,
+                                                       GError               **error);
 /*deprecated*/
 gboolean            ck_session_get_user               (CkSession             *session,
                                                        guint                 *uid,
@@ -171,6 +207,12 @@ gboolean            ck_session_get_idle_since_hint    (CkSession             *se
 gboolean            ck_session_set_idle_hint          (CkSession             *session,
                                                        gboolean               idle_hint,
                                                        DBusGMethodInvocation *context);
+gboolean            session_set_remove_on_close       (CkSession             *session,
+                                                       gboolean               remove_on_close,
+                                                       GError               **error);
+gboolean            ck_session_set_remove_on_close    (CkSession             *session,
+                                                       gboolean               remove_on_close,
+                                                       DBusGMethodInvocation *context);
 
 /* Privileged actions */
 gboolean            ck_session_activate               (CkSession             *session,
diff --git a/src/strverscmp.c b/src/strverscmp.c
new file mode 100644
index 0000000..f077651
--- /dev/null
+++ b/src/strverscmp.c
@@ -0,0 +1,131 @@
+/* Compare strings while treating digits characters numerically.
+   Copyright (C) 1997, 2000, 2002, 2004, 2006 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+   Contributed by Jean-François Bignolles <bignolle@ecoledoc.ibp.fr>, 1997.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License along
+   with this program; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+
+#if !_LIBC
+# include <config.h>
+#endif
+
+#include <string.h>
+#include <ctype.h>
+
+/* states: S_N: normal, S_I: comparing integral part, S_F: comparing
+           fractional parts, S_Z: idem but with leading Zeroes only */
+#define S_N    0x0
+#define S_I    0x4
+#define S_F    0x8
+#define S_Z    0xC
+
+/* result_type: CMP: return diff; LEN: compare using len_diff/diff */
+#define CMP    2
+#define LEN    3
+
+
+/* ISDIGIT differs from isdigit, as follows:
+   - Its arg may be any int or unsigned int; it need not be an unsigned char
+     or EOF.
+   - It's typically faster.
+   POSIX says that only '0' through '9' are digits.  Prefer ISDIGIT to
+   isdigit unless it's important to use the locale's definition
+   of `digit' even when the host does not conform to POSIX.  */
+#define ISDIGIT(c) ((unsigned int) (c) - '0' <= 9)
+
+#undef __strverscmp
+#undef strverscmp
+
+#ifndef weak_alias
+# define __strverscmp strverscmp
+#endif
+
+/* Compare S1 and S2 as strings holding indices/version numbers,
+   returning less than, equal to or greater than zero if S1 is less than,
+   equal to or greater than S2 (for more info, see the texinfo doc).
+*/
+
+int
+__strverscmp (const char *s1, const char *s2)
+{
+  const unsigned char *p1 = (const unsigned char *) s1;
+  const unsigned char *p2 = (const unsigned char *) s2;
+  unsigned char c1, c2;
+  int state;
+  int diff;
+
+  /* Symbol(s)    0       [1-9]   others  (padding)
+     Transition   (10) 0  (01) d  (00) x  (11) -   */
+  static const unsigned int next_state[] =
+  {
+      /* state    x    d    0    - */
+      /* S_N */  S_N, S_I, S_Z, S_N,
+      /* S_I */  S_N, S_I, S_I, S_I,
+      /* S_F */  S_N, S_F, S_F, S_F,
+      /* S_Z */  S_N, S_F, S_Z, S_Z
+  };
+
+  static const int result_type[] =
+  {
+      /* state   x/x  x/d  x/0  x/-  d/x  d/d  d/0  d/-
+                 0/x  0/d  0/0  0/-  -/x  -/d  -/0  -/- */
+
+      /* S_N */  CMP, CMP, CMP, CMP, CMP, LEN, CMP, CMP,
+                 CMP, CMP, CMP, CMP, CMP, CMP, CMP, CMP,
+      /* S_I */  CMP, -1,  -1,  CMP,  1,  LEN, LEN, CMP,
+                  1,  LEN, LEN, CMP, CMP, CMP, CMP, CMP,
+      /* S_F */  CMP, CMP, CMP, CMP, CMP, LEN, CMP, CMP,
+                 CMP, CMP, CMP, CMP, CMP, CMP, CMP, CMP,
+      /* S_Z */  CMP,  1,   1,  CMP, -1,  CMP, CMP, CMP,
+                 -1,  CMP, CMP, CMP
+  };
+
+  if (p1 == p2)
+    return 0;
+
+  c1 = *p1++;
+  c2 = *p2++;
+  /* Hint: '0' is a digit too.  */
+  state = S_N | ((c1 == '0') + (ISDIGIT (c1) != 0));
+
+  while ((diff = c1 - c2) == 0 && c1 != '\0')
+    {
+      state = next_state[state];
+      c1 = *p1++;
+      c2 = *p2++;
+      state |= (c1 == '0') + (ISDIGIT (c1) != 0);
+    }
+
+  state = result_type[state << 2 | ((c2 == '0') + (ISDIGIT (c2) != 0))];
+
+  switch (state)
+    {
+    case CMP:
+      return diff;
+
+    case LEN:
+      while (ISDIGIT (*p1++))
+	if (!ISDIGIT (*p2++))
+	  return 1;
+
+      return ISDIGIT (*p2) ? -1 : diff;
+
+    default:
+      return state;
+    }
+}
+#ifdef weak_alias
+weak_alias (__strverscmp, strverscmp)
+#endif
diff --git a/src/strverscmp.h b/src/strverscmp.h
new file mode 100644
index 0000000..48670c8
--- /dev/null
+++ b/src/strverscmp.h
@@ -0,0 +1,25 @@
+/* Compare strings while treating digits characters numerically.
+   Copyright (C) 1997, 2000, 2002, 2004, 2006 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+   Contributed by Jean-François Bignolles <bignolle@ecoledoc.ibp.fr>, 1997.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License along
+   with this program; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+
+#ifndef STRVERSCMP_H_
+# define STRVERSCMP_H_
+
+int strverscmp (const char *, const char *);
+
+#endif /* not STRVERSCMP_H_ */
diff --git a/tools/Makefile.am b/tools/Makefile.am
index 13c191f..fa16c68 100644
--- a/tools/Makefile.am
+++ b/tools/Makefile.am
@@ -54,6 +54,7 @@ sbin_PROGRAMS = \
 	ck-log-system-start		\
 	ck-log-system-restart		\
 	ck-log-system-stop		\
+	ck-seat-tool			\
 	$(NULL)
 
 ck_launch_session_SOURCES =		\
@@ -83,6 +84,14 @@ ck_history_LDADD =			\
 	$(top_builddir)/src/libck-event-log.la	\
 	$(NULL)
 
+ck_seat_tool_SOURCES =			\
+	ck-seat-tool.c			\
+	$(NULL)
+
+ck_seat_tool_LDADD =			\
+	$(CONSOLE_KIT_LIBS)		\
+	$(NULL)
+
 ck_log_system_start_SOURCES =		\
 	ck-log-system-start.c		\
 	$(NULL)
